using Dapfor.Net.Formats;

namespace Dapfor.Net.Demo.Examples.DataBinding.HierarchicalDatabinding
{
    public class Order
    {
        private readonly string _orderId;
        private readonly string _product;
        private readonly int _quantity;
        private readonly double _unitPrice;


        public Order(string orderId, string product, int quantity, double unitPrice)
        {
            _orderId = orderId;
            _product = product;
            _quantity = quantity;
            _unitPrice = unitPrice;
        }

        public string OrderId
        {
            get { return _orderId; }
        }

        public string Product
        {
            get { return _product; }
        }

        public int Quantity
        {
            get { return _quantity; }
        }

        [DoubleFormat(2)]
        public double UnitPrice
        {
            get { return _unitPrice; }
        }

        [DoubleFormat(2)]
        public double TotalPrice
        {
            get { return _unitPrice * _quantity; }
        }
    }
}