using System.Drawing;
using System.Windows.Forms;
using Dapfor.Net.Demo.Properties;
using Dapfor.Net.Editors;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.Features.SharedData
{
    internal class BulletComboEditor : DropDownEditor
    {
        public override void Populate(ListBox listBox, object value, ref ContentAlignment alignment)
        {
            listBox.Items.Add("Grey");
            listBox.Items.Add("Green");
            listBox.Items.Add("Blue");
            listBox.Items.Add("Yellow");
            listBox.Items.Add("Red");
        }

        public override object EndEdit(ListBox listBox, object value)
        {
            return (listBox.SelectedIndex >= 0 && listBox.SelectedIndex < 5) ? listBox.SelectedIndex : value;
        }

        public override bool GetPaintCellSupported()
        {
            return true;
        }

        public override void PaintCell(PaintCellEventArgs e)
        {
            switch ((int)e.Cell.Value)
            {
                case 0:
                    e.Image = Resources.bullet_ball_glass_grey;
                    break;
                case 1:
                    e.Image = Resources.bullet_ball_glass_green;
                    break;
                case 2:
                    e.Image = Resources.bullet_ball_glass_blue;
                    break;
                case 3:
                    e.Image = Resources.bullet_ball_glass_yellow;
                    break;
                case 4:
                    e.Image = Resources.bullet_ball_glass_red;
                    break;
            }
            base.PaintCell(e);
        }
    }
}