using System.Globalization;
using Dapfor.Net.Data;
using Dapfor.Net.Formats;

namespace Dapfor.Net.Demo.Examples.GridBasics.DataSourceFiltering
{
    /// <summary>
    /// Formats and parses Long-type values
    /// </summary>
    public class LongFormat : IFormat
    {
        #region IFormat Members

        public string Format(IDataField dataField)
        {
            string value = string.Empty;
            if (dataField.Value != null)
            {
                value = string.Format(CultureInfo.InvariantCulture, "{0:### ### ### ### ### ### ### ###}", dataField.Value).Trim();
            }

            return value;
        }

        public bool CanParse(string text, IDataField dataField)
        {
            return true;
        }

        public void Parse(string text, IDataField dataField)
        {
            long value = 0;
            text = text.Replace(" ", "");
            text = text.Replace(",", ".");
            text = text.Trim();
            if (!string.IsNullOrEmpty(text))
            {
                if (!long.TryParse(text, NumberStyles.Number, CultureInfo.InvariantCulture, out value))
                {
                    value = 0;
                }
            }

            dataField.Value = value;
        }

        #endregion
    }
}