using System;
using Dapfor.Net.Data;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.Performance.FilterPerformance
{
    /// <summary>
    /// The objects of this class will be inserted into the <see cref="Grid"/>. 
    /// </summary>
    public class DataObject : IGetAccelerator
    {
        #region Fields 

        private readonly int value0;
        private readonly int value1;
        private readonly int value2;
        private readonly int value3;
        private readonly int value4;
        private readonly int value5;
        private readonly int value6;
        private readonly int value7;
        private readonly int value8;
        private readonly int value9;

        #endregion

        #region Public properties

        public DataObject(Random r)
        {
            if (r != null)
            {
                value0 = r.Next()%30;
                value1 = r.Next()%100;
                value2 = r.Next()%200;
                value3 = r.Next()%400;
                value4 = r.Next()%30;
                value5 = r.Next()%600;
                value6 = r.Next()%30;
                value7 = r.Next()%800;
                value8 = r.Next()%900;
                value9 = r.Next()%1000;
            }
        }

        [Field("Id0")]
        public int Value0
        {
            get { return value0; }
        }

        [Field("Id1")]
        public int Value1
        {
            get { return value1; }
        }

        [Field("Id2")]
        public int Value2
        {
            get { return value2; }
        }

        [Field("Id3")]
        public int Value3
        {
            get { return value3; }
        }

        [Field("Id4")]
        public int Value4
        {
            get { return value4; }
        }

        [Field("Id5")]
        public int Value5
        {
            get { return value5; }
        }

        [Field("Id6")]
        public int Value6
        {
            get { return value6; }
        }

        [Field("Id7")]
        public int Value7
        {
            get { return value7; }
        }

        [Field("Id8")]
        public int Value8
        {
            get { return value8; }
        }

        [Field("Id9")]
        public int Value9
        {
            get { return value9; }
        }

        #endregion

        public IGetter GetGetter(IDataField field)
        {
            //This method accelerates the values getting. If our case, the DataObject implements the 
            //IGetAccelerator interface and the Grid will try to get values by calling this method 
            //instead of using the reflection mechanism. 
            //ValueGetter - just a container for values, returned by Value0..Value9 properties

            switch (field.Id)
            {
                case "Id0":
                    return new ValueGetter(Value0);
                case "Id1":
                    return new ValueGetter(Value1);
                case "Id2":
                    return new ValueGetter(Value2);
                case "Id3":
                    return new ValueGetter(Value3);
                case "Id4":
                    return new ValueGetter(Value4);
                case "Id5":
                    return new ValueGetter(Value5);
                case "Id6":
                    return new ValueGetter(Value6);
                case "Id7":
                    return new ValueGetter(Value7);
                case "Id8":
                    return new ValueGetter(Value8);
                case "Id9":
                    return new ValueGetter(Value9);
            }
            return null;
        }
    }
}