using System;
using System.ComponentModel;
using Dapfor.Net.Data;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Demo.Examples.Performance.RealtimeUpdates
{
    /// <summary>
    /// The objects of this class will be inserted into the <see cref="Grid"/>. When a field of this object is changed, 
    /// it notifies the <see cref="Grid"/> through the <see cref="INotifyPropertyChanged"/> interface. If the notification 
    /// comes from the non-GUI thread, the <see cref="Grid"/> will do the synchronization itself.
    /// </summary>
    public class DataObject : INotifyPropertyChanged
    {
        #region Fields 

        private int _value0;
        private int _value1;
        private int _value2;
        private int _value3;
        private int _value4;
        private int _value5;
        private int _value6;
        private int _value7;
        private int _value8;
        private int _value9;

        #endregion

        #region Public properties

        public DataObject(Random r)
        {
            if (r != null)
            {
                _value0 = r.Next();
                _value1 = r.Next();
                _value2 = r.Next();
                _value3 = r.Next();
                _value4 = r.Next();
                _value5 = r.Next();
                _value6 = r.Next();
                _value7 = r.Next();
                _value8 = r.Next();
                _value9 = r.Next();
            }
        }

        [Field("Id0")]
        public int Value0
        {
            get { return _value0; }
            set
            {
                _value0 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id0"));
                }
            }
        }

        [Field("Id1")]
        public int Value1
        {
            get { return _value1; }
            set
            {
                _value1 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id1"));
                }
            }
        }

        [Field("Id2")]
        public int Value2
        {
            get { return _value2; }
            set
            {
                _value2 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id2"));
                }
            }
        }

        [Field("Id3")]
        public int Value3
        {
            get { return _value3; }
            set
            {
                _value3 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id3"));
                }
            }
        }

        [Field("Id4")]
        public int Value4
        {
            get { return _value4; }
            set
            {
                _value4 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id4"));
                }
            }
        }

        [Field("Id5")]
        public int Value5
        {
            get { return _value5; }
            set
            {
                _value5 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id5"));
                }
            }
        }

        [Field("Id6")]
        public int Value6
        {
            get { return _value6; }
            set
            {
                _value6 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id6"));
                }
            }
        }

        [Field("Id7")]
        public int Value7
        {
            get { return _value7; }
            set
            {
                _value7 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id7"));
                }
            }
        }

        [Field("Id8")]
        public int Value8
        {
            get { return _value8; }
            set
            {
                _value8 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id8"));
                }
            }
        }

        [Field("Id9")]
        public int Value9
        {
            get { return _value9; }
            set
            {
                _value9 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Id9"));
                }
            }
        }

        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}