using System;

namespace Dapfor.Net.Demo.Internal
{
    /// <summary>
    /// Specifies a type of example and meta information, describing the demo
    /// </summary>
    public sealed class ExampleInfo
    {
        private readonly Type exampleType;
        private readonly ExampleAttribute metaData;

        public ExampleInfo(ExampleAttribute metaData, Type exampleType)
        {
            this.metaData = metaData;
            this.exampleType = exampleType;
        }

        public ExampleAttribute MetaData
        {
            get { return metaData; }
        }

        public Type ExampleType
        {
            get { return exampleType; }
        }
    }
}
